Imports System.EnterpriseServices
Imports System.Configuration
Imports System.Data.SqlClient

<Transaction(TransactionOption.Required), ConstructionEnabled([Default]:="data source=localhost;initial catalog=ContactMgr;User ID=sa;Password=;")> _
Public Class Contact
    Inherits ServicedComponent

    Private cnString As String '= "data source=localhost;initial catalog=ContactMgr;User ID=sa;Password=;"
    Public Function AddContact(ByVal FirstName As String, ByVal LastName As String, ByVal Company As String, ByVal Phone As String, ByVal Email As String) As Integer

        Dim CurrentEmail As String
        Dim UserID As Integer

        Dim cnContactMgr As New SqlConnection(cnString)
        cnContactMgr.Open()

        'determine if record exists
        Try
            Dim pParam As New SqlParameter("@Email", SqlDbType.VarChar, 50)
            pParam.Value = Email
            Dim cmd As New SqlCommand("usp_ContactSelectByEmail", cnContactMgr)
            cmd.CommandType = CommandType.StoredProcedure
            cmd.Parameters.Add(pParam)
            CurrentEmail = Convert.ToString(cmd.ExecuteScalar())
        Finally
            'do nothing
        End Try


        If CurrentEmail = "" Then 'record does not exist

            'setup parameters
            Dim pInsParams(4) As SqlParameter
            pInsParams(0) = New SqlParameter("@FirstName", SqlDbType.VarChar, 20)
            pInsParams(0).Value = FirstName

            pInsParams(1) = New SqlParameter("@LastName", SqlDbType.VarChar, 20)
            pInsParams(1).Value = LastName

            pInsParams(2) = New SqlParameter("@Company", SqlDbType.VarChar, 20)
            pInsParams(2).Value = Company

            pInsParams(3) = New SqlParameter("@Phone", SqlDbType.Char, 10)
            pInsParams(3).Value = Phone

            pInsParams(4) = New SqlParameter("@Email", SqlDbType.VarChar, 40)
            pInsParams(4).Value = Email

            'setup SqlCommand
            Dim cmdInsert As New SqlCommand("usp_ContactInsert", cnContactMgr)
            cmdInsert.CommandType = CommandType.StoredProcedure

            'loop through the parameter array
            'and add each parameter to the SqlCommand object
            Dim i As Integer
            For i = 0 To pInsParams.Length - 1
                cmdInsert.Parameters.Add(pInsParams(i))
            Next

            UserID = Convert.ToInt32(cmdInsert.ExecuteScalar())
            ContextUtil.SetComplete()
        Else
            UserID = 0
            ContextUtil.SetAbort()
        End If

        'close the connection and return the UserID
        cnContactMgr.Close()
        Return UserID
    End Function

    <AutoComplete(True)> _
    Public Function DeleteContact(ByVal UserID As Integer) As Boolean

    End Function

    <AutoComplete(True)> _
    Public Function SelectContacts() As DataSet

    End Function

    <AutoComplete(True)> _
    Public Function SelectContact(ByVal UserID) As DataSet

    End Function

    Protected Overrides Sub Construct(ByVal constructString As String)
        cnString = constructString
    End Sub

End Class
